VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "DataBase"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit

Private Const adUseClient = 3
Private Const adModeShareDenyNone = 16
Private Const adOpenKeyset = 1
Private Const adLockOptimistic = 3

Public Type FindInfo
    FindIn As Variant
    ToFind As Variant
End Type

Public Function OpenDatabase(Connection As Object, ByVal DataBasePath As String, _
                             Optional User As String, Optional Password As String) As Long
    
    On Local Error GoTo Quit
    
    With Connection
        .CursorLocation = adUseClient
        .Mode = adModeShareDenyNone
        .Provider = "Microsoft.Jet.OLEDB.4.0"
        .Properties("Data Source") = DataBasePath
        
        If Password <> "" Then .Properties("Password") = Password
        If User <> "" Then .Properties("User") = User
        
        .Open
    End With

    Exit Function
    
Quit:
    OpenDatabase = Err.Number

    Call ERROR(DataBase, "OpenDatabase", Err.Number, Err.Description, "Databasepath: " & DataBasePath)
    
    Call CloseDataBase(Connection)
    
    Err.Clear

End Function
Public Function CloseDataBase(Connection As Object) As Long

    On Local Error GoTo Quit

    Connection.Close
       
Quit:
    CloseDataBase = Err.Number

    If Err.Number <> 0 Then Call ERROR(DataBase, "CloseDataBase", Err.Number, Err.Description)

    Set Connection = Nothing

    Err.Clear
    
End Function
Public Function SelectTable(Connection As Object, _
                            Recordset As Object, ByVal Table As String, _
                            Optional SortBy As String = "") As Long
    
    On Local Error Resume Next
    
    Recordset.Close
    Err.Clear
    
    On Local Error GoTo Quit
    
    With Recordset
        .ActiveConnection = Connection
        .CursorLocation = adUseClient
        .CursorType = adOpenKeyset
        .LockType = adLockOptimistic
        
        If SortBy = "" Then
            .Source = "SELECT * FROM " & Table
        Else
            .Source = "SELECT * FROM " & Table & " ORDER BY " & SortBy
        End If
        
        .Open
    End With
    
    On Local Error Resume Next
    
    Recordset.MoveFirst
    Err.Clear
    
    Exit Function
    
Quit:
    SelectTable = Err.Number
    
    Call ERROR(DataBase, "SelectTable", Err.Number, Err.Description, "Table: " & Table)
    
    Err.Clear
    
End Function
Public Function Find(Recordset As Object, _
                     ByVal FindIn As String, sFind As String, _
                     Optional ErrorNumber As Long) As Boolean
    Dim SQL As String
    
    On Local Error Resume Next
    
    ErrorNumber = 0
    
    Recordset.MoveFirst
    Err.Clear
    
    On Local Error GoTo Quit
    
    SQL = FindIn & " = '" & sFind & "'"
    
    Recordset.Find SQL
    
    Find = Not (Recordset.EOF)
    
    Exit Function
    
Quit:
    ErrorNumber = Err.Number
    
    Call ERROR(DataBase, "Find", Err.Number, Err.Description)
    
    Err.Clear
    
End Function
Public Function Find_Multi(Recordset As Object, Find() As FindInfo, _
                           Optional ErrorNumber As String) As Boolean
    Dim P As Long
    Dim DB As String, F$, SQL As String
    Dim Found As Boolean
       
    ErrorNumber = 0
    
    With Recordset
        On Local Error Resume Next
        
        .MoveFirst
        Err.Clear
        
        On Local Error GoTo Quit
    
        SQL = Find(LBound(Find)).FindIn & " = '" & Find(LBound(Find)).ToFind & "'"
        
        Recordset.Find SQL
        
        Do While Not .EOF
            Found = True
            
            For P = LBound(Find) To UBound(Find)
                DB = .Fields(Find(P).FindIn)
                F$ = CStr(Find(P).ToFind)
                
                If DB <> F$ Then
                    Found = False
                    
                    Exit For
                End If
            Next P
            
            If Found Then
                Find_Multi = True
                
                Exit Do
            End If
            
            .MoveNext
        Loop
    End With

    Exit Function
    
Quit:
    ErrorNumber = Err.Number
    
    Call ERROR(DataBase, "Find_Multi", Err.Number, Err.Description)
    
    Err.Clear
                
End Function
Public Function Exist(Recordset As Object, ByVal sFind As String, FindIn As Variant, _
                      Optional ErrorNumber As Long) As Boolean
    
    Exist = Find(Recordset, FindIn, sFind, ErrorNumber)
    
End Function
Public Function CreateDatabase(ByVal Path As String, _
                               Optional DeleteExist As Boolean = True) As Long
    Dim C$
    Dim objCatalog As Object
  
    On Local Error GoTo Quit
  
    If DeleteExist Then
        Call DLL.File.fKill(Path)
    Else
        If DLL.File.Exist(Path) Then
            CreateDatabase = -1
            
            Exit Function
        End If
    End If
  
    C$ = "Provider=Microsoft.Jet.OLEDB.4.0; Jet OLEDB:Engine Type=5;Data Source=" & Path & ""
    
    Set objCatalog = CreateObject("ADOX.Catalog")
  
    objCatalog.Create C$
  
    Set objCatalog = Nothing

    Exit Function

Quit:
    CreateDatabase = Err.Number
    
    Call ERROR(DataBase, "CreateDatabase", Err.Number, Err.Description)
    
    Set objCatalog = Nothing
    
    Err.Clear
    
End Function
Public Function TableCreate(Connection As Object, ByVal Table As String) As Long
        
    On Local Error GoTo Quit
    
    Connection.Execute "CREATE TABLE " & Table
    
    Exit Function

Quit:
    TableCreate = Err.Number
    
    Call ERROR(DataBase, "TableCreate", Err.Number, Err.Description)
    
    Err.Clear
    
End Function
Public Function TableDelete(Connection As Object, ByVal Table As String) As Long
    
    On Local Error GoTo Quit
    
    Connection.Execute "DROP TABLE " & Table
    
    Exit Function

Quit:
    TableDelete = Err.Number
   
    Call ERROR(DataBase, "TableDelete", Err.Number, Err.Description)

    Err.Clear
    
End Function
Public Function Export(Recordset As Object, ByVal Path As String) As Long
    Dim P As Long
    Dim R$
    
    On Local Error Resume Next
    
    Recordset.MoveFirst
    Err.Clear
    
    On Local Error GoTo Quit
    
    For P = 0 To Recordset.Fields.Count - 1
        R$ = R$ & Chr$(34) & Recordset.Fields(P).NAME & Chr$(34) & ","
    Next P
    
    R$ = mID(R$, 1, Len(R$) - 1) & vbCrLf
    
    Do While Not Recordset.EOF
        For P = 0 To Recordset.Fields.Count - 1
            R$ = R$ & Chr$(34) & Recordset.Fields(P) & Chr$(34) & ","
        Next P
        
        R$ = mID(R$, 1, Len(R$) - 1) & vbCrLf
        Recordset.MoveNext
    Loop
    
    Export = DLL.TEXT.TextFile_WriteText(Path, R$)
    
    Exit Function

Quit:
    Export = Err.Number
   
    Call ERROR(DataBase, "Export", Err.Number, Err.Description)
    
    Err.Clear
    
End Function
Public Function ColumnExist(Recordset As Object, ByVal Column As String, _
                            Optional ErrorNumber As Long) As Boolean
    Dim P As Long
        
    On Local Error GoTo Quit
    
    ErrorNumber = 0
    
    Column = LCase$(Column)
    
    For P = 0 To Recordset.Fields.Count - 1
        If LCase$(Recordset.Fields(P).NAME) = Column Then
            ColumnExist = True
            
            Exit For
        End If
    Next P
    
    Exit Function

Quit:
    ErrorNumber = Err.Number
    
    Call ERROR(DataBase, "ColumnExist", Err.Number, Err.Description)
    
    Err.Clear
    
End Function
Public Function isEMPTY(Recordset As Object, Optional ErrorNumber As Long) As Boolean

    On Local Error GoTo Quit
    
    ErrorNumber = 0
    
    isEMPTY = (Recordset.RecordCount = 0)
    
    Exit Function

Quit:
    ErrorNumber = Err.Number

    Call ERROR(DataBase, "isEMPTY", Err.Number, Err.Description)
    
    Err.Clear
    
End Function
Public Function TableExist(Cn As Object, ByVal Table As String, _
                           Optional ErrorNumber As Long) As Boolean
    Dim R$()
    
    R$ = TableList(Cn, ErrorNumber)
    
    If ErrorNumber = 0 Then
        TableExist = DLL.ARRAY.Find(R$, Table, , , False, ErrorNumber)
    Else
        TableExist = False
    End If
    
End Function
Public Function TableCount(Cn As Object, Optional ErrorNumber As Long) As Long
    Dim R$()
    
    On Local Error GoTo Quit
    
    R$ = TableList(Cn, ErrorNumber)

    If ErrorNumber = 0 Then
        TableCount = UBound(R$) + 1
    Else
        TableCount = -2
    End If
    
    Exit Function

Quit:
    ErrorNumber = Err.Number
    
    Call ERROR(DataBase, "TableCount", Err.Number, Err.Description)
    
    Err.Clear
    
End Function
Public Function TableList(Cn As Object, Optional ErrorNumber As Long) As String()
    Dim Rs As Object
    Dim P As Long, x As Long
    Dim R$()
    
    Const adSchemaTables = 20
    
    On Local Error GoTo Quit
    
    ErrorNumber = 0
    
    Set Rs = Cn.OpenSchema(adSchemaTables)
        
    For P = 0 To Rs.RecordCount - 1
        If Rs.Fields("TABLE_TYPE") = "TABLE" Then
            ReDim Preserve R$(x)
            
            R$(x) = Rs.Fields("TABLE_NAME")
            x = x + 1
        End If
        
        Rs.MoveNext
    Next P
    
    TableList = R$
    
    Exit Function

Quit:
    ErrorNumber = Err.Number
    
    Call ERROR(DataBase, "TableList", Err.Number, Err.Description)
    
    Err.Clear
    
End Function
Public Function Sort(Connection As Object, _
                     Recordset As Object, ByVal Table As String, _
                     ByVal SortBy As String) As Long

    On Local Error Resume Next
    
    Recordset.Close
    Err.Clear
    
    On Local Error GoTo Quit
    
    With Recordset
        .ActiveConnection = Connection
        .CursorLocation = adUseClient
        .CursorType = adOpenKeyset
        .LockType = adLockOptimistic
        
        .Source = "SELECT * FROM " & Table & " ORDER BY " & SortBy
                
        .Open
    End With
    
    Exit Function

Quit:
    Sort = Err.Number
    
    Call ERROR(DataBase, "Sort", Err.Number, Err.Description, "Table: " & Table)
    
    Err.Clear
    
End Function
