VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "INI"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit

Private Declare Function WritePrivateProfileString Lib "kernel32" Alias "WritePrivateProfileStringA" (ByVal lpApplicationName As String, ByVal lpKeyName As Any, ByVal lpString As Any, ByVal lpFileName As String) As Long
Private Declare Function GetPrivateProfileString Lib "kernel32" Alias "GetPrivateProfileStringA" (ByVal lpApplicationName As String, ByVal lpKeyName As Any, ByVal lpDefault As String, ByVal lpReturnedString As String, ByVal nSize As Long, ByVal lpFileName As String) As Long
Private Declare Function DeletePrivateProfileSection Lib "kernel32" Alias "WritePrivateProfileStringA" (ByVal Section As String, ByVal NoKey As Long, ByVal NoSetting As Long, ByVal Filename As String) As Long
Private Declare Function GetPrivateProfileSection Lib "kernel32" Alias "GetPrivateProfileSectionA" (ByVal lpAppName As String, ByVal lpReturnedString As String, ByVal nSize As Long, ByVal lpFileName As String) As Long
Private Declare Function WritePrivateProfileSection Lib "kernel32.dll" Alias "WritePrivateProfileSectionA" (ByVal lpAppName As String, ByVal lpString As String, ByVal lpFileName As String) As Long

Public Function Read_INI(ByVal INIpath As String, ByVal Section As String, _
                         ByVal Key As String, Optional ReplacevbCrlf As String = "") As String
    Dim RetStr As String
   
    RetStr = STRING(255, Chr$(0))
   
    Read_INI = Left$(RetStr, GetPrivateProfileString(Section, Key, "", RetStr, Len(RetStr), INIpath))
                                            
    If ReplacevbCrlf <> "" Then Read_INI = Replace(Read_INI, ReplacevbCrlf, vbCrLf)

End Function
Public Function Write_INI(ByVal INIpath As String, _
                          ByVal Section As String, _
                          ByVal Abschnitt As String, _
                          ByVal Value As String, _
                          Optional ReplacevbCrlf As String = "") As Boolean
    
    If ReplacevbCrlf <> "" Then Value = Replace(Value, vbCrLf, ReplacevbCrlf)
    
    If WritePrivateProfileString(Section, Abschnitt, Value, INIpath) Then Write_INI = True

End Function
Public Sub RemoveSection(ByVal INIpath As String, ByVal Section As String)
    
    Call DeletePrivateProfileSection(Section, 0, 0, INIpath)

End Sub
Public Function ReadSection(ByVal INIpath As String, _
                            ByVal Section As String) As String()
    Dim Result As Long, L As Long, P As Long, Z As Long, x As Long
    Dim Buffer As String, A() As String
            
    Buffer = Space(32767)
    Result = GetPrivateProfileSection(Section, Buffer, Len(Buffer), INIpath)
    
    Buffer = Left$(Buffer, Result)
    
    If Buffer <> "" Then
        L = 1
        Z = 0
        
        Do While L < Result
            P = InStr(L, Buffer, Chr$(0))
            If P = 0 Then Exit Do
            
            ReDim Preserve A(Z)
            
            A(Z) = mID$(Buffer, L, P - L)
            
            Z = Z + 1
            L = P + 1
        Loop
    End If

    If DLL.ARRAY.Get_LBound(A) > -1 Then
        For P = 0 To UBound(A)
            x = InStr(A(P), "=")
            A(P) = mID(A(P), x + 1)
            A(P) = Trim(A(P))
        Next P
    End If
    
    ReadSection = A

End Function
Public Sub DeleteKey(ByVal INIpath As String, ByVal Section As String, _
                     ByVal Key As String)
    
    Call WritePrivateProfileString(Section, Key, vbNullString, INIpath)

End Sub
Public Function ReadArray(ByVal INIpath As String, ByVal Section As String) As String()
    Dim R$
    Dim A() As String
    Dim BufferLen As Long, tlngRetLen As Long, tlngDataCount As Long, tlngLen1 As Long, tlngLen2 As Long
    
    On Local Error GoTo Quit
    
    Do
        BufferLen = BufferLen + 32767
        R$ = Space(BufferLen)
        
        tlngRetLen = GetPrivateProfileSection(Section, R$, BufferLen, INIpath)
    Loop While (tlngRetLen + 2 = BufferLen)
    
    Erase A
    
    tlngDataCount = 0
    tlngLen1 = 1
    
    Do While (tlngLen1 < tlngRetLen)
        tlngDataCount = tlngDataCount + 1
        ReDim Preserve A(tlngDataCount - 1)
        tlngLen2 = InStr(tlngLen1, R$, Chr$(0))
        
        A(tlngDataCount - 1) = mID$(R$, tlngLen1, tlngLen2 - tlngLen1)
        
        tlngLen1 = tlngLen2 + 1
    Loop
    
Quit:
    If Err.Number <> 0 Then Erase A
    
    ReadArray = A

    Err.Clear

End Function
Public Function WriteArray(ByVal INIpath As String, ByVal Section As String, _
                           sArray As Variant, _
                           Optional ErrorNumber As Long) As Boolean
    Dim tlngCounter As Long
    Dim R$
    
    On Local Error GoTo Quit
    
    ErrorNumber = 0
    
    Call RemoveSection(INIpath, Section)

    For tlngCounter = LBound(sArray) To UBound(sArray)
        R$ = R$ & sArray(tlngCounter) & Chr$(0)
    Next tlngCounter
    
    R$ = Left$(R$, Len(R$) - 1)
    
    WriteArray = (WritePrivateProfileSection(Section, R$, INIpath) = 1)

    Exit Function
    
Quit:
    ErrorNumber = Err.Number
    
    Call ERROR(INI, "WriteArray", Err.Number, Err.Description)
    
    Err.Clear
    
End Function
